local tz = 3 -- !!!!!!!!!!
local key = "key" -- !!!!!!!!!!!!!!!!!
local city = 'Shablykino'  -- !!!!!!!!!!
print('city:'..city)
local request = "GET http://api.openweathermap.org/data/2.5/forecast?q="..city.."&mode=xml&units=metric&cnt=9&appid="..key.." HTTP/1.1\r\n" ..
"Host: api.openweathermap.org\r\n"

local _conn, stop_stream, data_received, cb_disconnected
local _skip_headers = true
local _chunk = ""
local frame = "T15"
local gotcode = false
local tm = rtctime.epoch2cal(rtctime.get())
local hour = tm["hour"] + tz
print('\n\t\t\thour now:', hour) 
if hour >= 15 and hour < 21 then frame = "T03" end

stop_stream = function(c)
  if _conn then
    _conn:close()
    _conn = nil
  end
  c = nil
end

data_received = function(c, data)
  if _skip_headers then
    _chunk = _chunk..data
    local i, j = string.find(_chunk, frame)
    if i then
      _skip_headers = false
      data = string.sub(_chunk, j+1, -1)
      _chunk = data
    else
      _chunk = ""
    end
  end

  if not _skip_headers then
    if gotcode then _chunk = _chunk..data end
    local code = string.match(_chunk, ':00"><symbol number="(%d+)' )
    local tempavg = string.match(_chunk, 's" value="(%p*%d+%p*%d*)' )
    local sky = string.match(data, 'value="(%a+%s*%a*)' )
    if code and tempavg then
      print('\n\t\t\tGot Data to '..frame..':00')
      print('\t\t\tGot Code:', code, tempavg)
      print('\t\t\tSky:', sky)
      wth.codef = tonumber(code)
      wth.mintemp = tempavg
      wth.maxtemp = tempavg
      stop_stream(c)
    else
        gotcode = true
    end
  end
end

cb_disconnected = function()
  print("Disconnected")
end

_conn = net.createConnection(net.TCP, 0)
_conn:on("connection", function(conn, payload) conn:send(request.."Connection: close\r\nAccept: /\r\n\r\n") end)
_conn:on("receive", data_received)
_conn:on("disconnection", cb_disconnected)
_conn:connect(80, 'api.openweathermap.org')